// Example 4: do a contour and a clip-with-field, and write it out.
//
#include <vtkm/io/reader/VTKDataSetReader.h>
#include <vtkm/io/writer/VTKDataSetWriter.h>
#include <vtkm/filter/MarchingCubes.h>
#include <vtkm/filter/ClipWithField.h>


int main()
{
  const char *input = "kitchen.vtk";
  vtkm::io::reader::VTKDataSetReader reader(input);
  vtkm::cont::DataSet ds_from_file = reader.ReadDataSet();

  vtkm::filter::MarchingCubes mc;
  mc.SetActiveField("c1");
  mc.SetFieldsToPass({ "c1", "ke" });
  mc.SetNumberOfIsoValues(3);
  mc.SetIsoValue(0, 0.05);
  mc.SetIsoValue(1, 0.10);
  mc.SetIsoValue(2, 0.15);
  vtkm::cont::DataSet ds_from_mc = mc.Execute(ds_from_file);

  vtkm::filter::ClipWithField clip;
  clip.SetActiveField("ke");
  clip.SetClipValue(1e-7);
  //clip.SetInvertClip(true); // <1e-7 instead of >1e-7

  vtkm::cont::DataSet ds_from_clip = clip.Execute(ds_from_mc);

  vtkm::io::writer::VTKDataSetWriter writer("out_2filters.vtk");
  writer.WriteDataSet(ds_from_clip);

  return 0;
}
