#include <vtkm/io/reader/VTKDataSetReader.h>
#include <vtkm/io/writer/VTKDataSetWriter.h>
#include <vtkm/filter/MarchingCubes.h>


int main()
{
  try
  {
    const char *input = "kitchen.vtk";
    vtkm::io::reader::VTKDataSetReader reader(input);

    // PROBLEM! ... we aren't reading from a file, so we have an empty vtkm::cont::DataSet.
    //vtkm::cont::DataSet ds_from_file = reader.ReadDataSet();
    vtkm::cont::DataSet ds_from_file;

    vtkm::filter::MarchingCubes mc;
    mc.SetActiveField("c1");
    mc.SetNumberOfIsoValues(3);
    mc.SetIsoValue(0, 0.05);
    mc.SetIsoValue(1, 0.10);
    mc.SetIsoValue(2, 0.15);

    vtkm::cont::DataSet ds_from_mc = mc.Execute(ds_from_file);
    vtkm::io::writer::VTKDataSetWriter writer("out_mc.vtk");
    writer.WriteDataSet(ds_from_mc);
  }
  catch (const vtkm::cont::Error& error) {
    std::cerr << "VTK-m error occurred!: " << error.GetMessage() << std::endl; 
    return 1;
  }	

  return 0;
}
