// Example 2: do a contour!, write it out.
//
#include <vtkm/io/reader/VTKDataSetReader.h>
#include <vtkm/io/writer/VTKDataSetWriter.h>
#include <vtkm/filter/MarchingCubes.h>


int main()
{
  const char *input = "kitchen.vtk";
  vtkm::io::reader::VTKDataSetReader reader(input);
  vtkm::cont::DataSet ds_from_file = reader.ReadDataSet();

  vtkm::filter::MarchingCubes mc;
  mc.SetActiveField("c1");
  mc.SetNumberOfIsoValues(3);
  mc.SetIsoValue(0, 0.05);
  mc.SetIsoValue(1, 0.10);
  mc.SetIsoValue(2, 0.15);

  vtkm::cont::DataSet ds_from_mc = mc.Execute(ds_from_file);
  vtkm::io::writer::VTKDataSetWriter writer("out_mc.vtk");
  writer.WriteDataSet(ds_from_mc);

  return 0;
}
